/* Jungo Connectivity Confidential. Copyright (c) 2016 Jungo Connectivity Ltd.  http://www.jungo.com */

/* 
 * This program is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU General Public License version 2 as published by
 * the Free Software Foundation.
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License v2 for
 * more details.
 * You should have received a copy of the GNU General Public License along with
 * this program. If not, contact Jungo Connectivity Ltd. at
 * support@jungo.com
 */

#ifndef _WDSRIOV_INTERFACE_H_
#define _WDSRIOV_INTERFACE_H_

#if defined(WD_DRIVER_NAME_CHANGE)
    #define DRIVER_NAME "RRadapter_sriov"
#else
    #define DRIVER_NAME "windrvr1221_sriov"
#endif

#if defined(WD_DRIVER_NAME_CHANGE) && defined(LINUX)
    #define WD_SRIOV_FUNC_NAME(func) RRadapter_sriov_##func
#else
    #define WD_SRIOV_FUNC_NAME(func) func
#endif

#if defined(__cplusplus)
    extern "C" {
#endif

int WD_SRIOV_FUNC_NAME(OS_pci_enable_sriov)(void *pdev, int nr_virtfn);

void WD_SRIOV_FUNC_NAME(OS_pci_disable_sriov)(void *pdev);

int WD_SRIOV_FUNC_NAME(OS_pci_sriov_is_vf)(void *pdev);

int WD_SRIOV_FUNC_NAME(OS_pci_sriov_is_assigned)(void *pdev);

int WD_SRIOV_FUNC_NAME(OS_pci_sriov_get_num_vf)(void *pdev);

int WD_SRIOV_FUNC_NAME(OS_pci_sriov_vf_get_owner)(void *pdev,
    unsigned long *dwBus, unsigned long *dwSlot, unsigned long *dwFunc);

#ifdef __cplusplus
}
#endif

#endif /* _WDSRIOV_INTERFACE_H_ */

